(lambda compnil [comp ?a ?b]
  (case [?a ?b]
    [a b]   (comp a b)
    [a nil] true
    [nil _] false))

;; compnil of (. heap i) and (. heap j), using comp and heap from the
;; environment.
(macro compheap [i j]
  `(compnil comp (. heap ,i) (. heap ,j)))
(macro swap [x y]
  `(set (,x ,y) (values ,y ,x)))

(lambda parent [i] (// i 2))
(lambda child1 [i] (* i 2))
(lambda child2 [i] (+ (* i 2) 1))

(lambda insert [heap comp x]
  (table.insert heap x)
  (var i (length heap))
  (while (and (> i 1) (compheap i (parent i)))
    (swap (. heap i) (. heap (parent i)))
    (set i (parent i))))

(lambda remove [heap comp]
  (let [x (. heap 1)]
    (set (. heap 1) (. heap (length heap)))
    (set (. heap (length heap)) nil)
    (var i 1)
    (while (or (compheap (child1 i) i)
               (compheap (child2 i) i))
      ;; Let c be the lesser of the two children.
      (let [c (if (compheap (child1 i) (child2 i))
                (child1 i)
                (child2 i))]
        (swap (. heap i) (. heap c))
        (set i c)))
    x))

(lambda iter [heap comp]
  (lambda []
    (remove heap comp)))

{: insert
 : remove
 : iter}
