;; Unload our own modules, to avoid old versions being cached in package.loaded
;; from a previous execution.
(each [_ modname (ipairs [:ff1 :ff1na :game :savestate :ucs :util])]
  (tset package.loaded modname nil))
;; Here we load a version-specific ff1 module, then additionally store it as
;; package.loaded.ff1. Other modules will require it simply as :ff1.
(local ff1 (require :ff1na)) (tset package.loaded :ff1 ff1)
(local game (require :game))
(local
  {: run
   : restore-savestate!}
  (require :savestate))

(lambda main [savestate]
  (-> savestate
      (game.title-menu 7)
      (game.party-select {:class ff1.CONST.CLS.FT
                          :name (assert (ff1.encode-text "Wedg"))}
                         {:class ff1.CONST.CLS.FT
                          :name (assert (ff1.encode-text "Bigs"))}
                         {:class ff1.CONST.CLS.FT
                          :name (assert (ff1.encode-text "Axe"))}
                         {:class ff1.CONST.CLS.FT
                          :name (assert (ff1.encode-text "Viks"))})
      ;; Sync the emulator state to the final computed savestate, in order to
      ;; save a movie.
      (restore-savestate!)))

(assert (run main))
